#include "Bass.au3"
#include "BassConstants.au3"
#include "Bassmix.au3"

Global $hMusicHandle, $hMixerHandle, $iSongLength

_BASS_Startup("Bass.dll")
_BASS_MIX_Startup("BassMix.dll")

_BASS_Init($BASS_DEVICE_SPEAKERS, -1, 44100, 0, "")
If @error Then
	MsgBox(0, "Error", "Could not initialize audio")
	Exit
EndIf

$hGui=GUICreate("Karaoke Mode Test",320,80)
$hSlider=GUICtrlCreateSlider(10,10,300,30)
$hButtonLoad=GUICtrlCreateButton("Load Song",10,50,145,20)
$hButtonEnable=GUICtrlCreateButton("Enable Karaokemode",165,50,145,20)
GUISetState()


$bKaraoke=False
While 1
	$msg=GUIGetMsg()
	Switch $msg
		Case -3
			_Exit()
		Case $hButtonEnable
			Switch $bKaraoke
			Case True
				$bKaraoke=False
				SetMatrix($hMusicHandle, 1, 1)
				GUICtrlSetData($hButtonEnable,"Enable KaraokeMode")
			Case Else
				$bKaraoke=True
				SetMatrix($hMusicHandle, 1, -1)
				GUICtrlSetData($hButtonEnable,"Disable KaraokeMode")
			EndSwitch
		Case $hButtonLoad
			If $hMusicHandle Then
				_BASS_ChannelStop($hMixerHandle)
				_BASS_StreamFree($hMusicHandle)
			EndIf
			$sFile=FileOpenDialog("Open...", "", "MP3 Files (*.mp3)")
			$hMusicHandle = _BASS_StreamCreateFile(False, $sFile, 0, 0, $BASS_STREAM_DECODE + $BASS_SAMPLE_FLOAT + $BASS_SAMPLE_LOOP)
			$aInfo = _BASS_ChannelGetInfo($hMusicHandle)
			$hMixerHandle = _BASS_Mixer_StreamCreate($aInfo[0], 1, 0)
			_BASS_Mixer_StreamAddChannel($hMixerHandle, $hMusicHandle, $BASS_MIXER_MATRIX)
			$iSongLength=_BASS_ChannelGetLength($hMusicHandle, $BASS_POS_BYTE)
			_BASS_ChannelPlay($hMixerHandle, False)
		Case $hSlider
			If $hMusicHandle And $iSongLength Then
				$iPos=Round(GUICtrlRead($hSlider)*$iSongLength/100)
				_BASS_ChannelSetPosition($hMusicHandle, $iPos, $BASS_POS_BYTE)
			EndIf
	EndSwitch
	Sleep(20)
	$aInfo=GUIGetCursorInfo($hGui)
	If Not $aInfo[2] And $aInfo[4] <> $hSlider And $hMusicHandle And $iSongLength Then
		$iPos=_BASS_ChannelGetPosition($hMusicHandle, $BASS_POS_BYTE)
		GUICtrlSetData($hSlider,$iPos*100/$iSongLength)
	EndIf
WEnd


Func SetMatrix($handle, $left, $right)
    Local $tStruct = DllStructCreate("float;float")
    DllStructSetData($tStruct, 1, $left)
    DllStructSetData($tStruct, 2, $right)
    _BASS_Mixer_ChannelSetMatrix($handle, DllStructGetPtr($tStruct))
EndFunc   ;==>SetMatrix


Func _Exit()
	_BASS_Free()
	Exit
EndFunc   ;==>OnAutoItExit
